/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.29 by edhill, Tue Nov 11 20:38:27 2003 UTC revision 1.37 by heimbach, Fri Nov 14 05:25:46 2003 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/sh
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 104  find_possible_configs()  { Line 104  find_possible_configs()  {
104          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
105      fi      fi
106    
107        # makedepend is not always available
108        if test "x${MAKEDEPEND}" = x ; then
109          which makedepend >& /dev/null
110          RETVAL=$?
111          if test "x${RETVAL}" = x1 ; then
112             echo "    makedepend was not found. Using xmakedpend instead."
113             MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
114          fi
115        fi
116    
117      # look for possible fortran compilers      # look for possible fortran compilers
118      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
119      p_FC=      p_FC=
# Line 206  get_pdepend_list()  { Line 216  get_pdepend_list()  {
216      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
217          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
218          > ./.pd_tmp          > ./.pd_tmp
219      source ./.pd_tmp      . ./.pd_tmp
220      rm -f ./.pd_tmp      rm -f ./.pd_tmp
221    
222      echo -n "PNAME = "${}      echo -n "PNAME = "${}
# Line 264  usage()  { Line 274  usage()  {
274      exit 1      exit 1
275  }  }
276    
277  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
278  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
279  #eh3 set CPP        = ( '/lib/cpp -P' )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
280  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      
281  #eh3 set KPP        = (  )      cat > genmake_test.c <<EOF
282  #eh3 set FC         = ( 'f77' )  void tcall( char * string ) { tsub( string ); }
283  #eh3 set LINK       = $FC  EOF
284  #eh3 set MAKEDEPEND = ( 'makedepend' )      $MAKE genmake_test.o > genmake_test.log 2>&1
285  #eh3 set INCLUDES   = ( -I. )      RETVAL=$?
286  #eh3 set FFLAGS     = (  )      if test "x$RETVAL" != x0 ; then
287  #eh3 set FOPTIM     = (  )          cat genmake_test.log >> genmake_errors
288  #eh3 set CFLAGS     = (  )          FC_NAMEMANGLE=$default_nm
289  #eh3 set KFLAGS1    = (  )          echo
290  #eh3 set KFLAGS2    = (  )          echo "WARNING: C test compile fails -- please see \"genmake_errors\""
291  #eh3 set LIBS       = (  )          echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
292  #eh3 set KPPFILES   = (  )          echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
293  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          return 1
294  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )      fi
295        c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`
296        RETVAL=$?
297        if test "x$RETVAL" != x0 ; then
298            FC_NAMEMANGLE=$default_nm
299            echo
300            echo "WARNING: The \"nm\" command failed."
301            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
302            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
303            return 1
304        fi
305        cat > genmake_tcomp.f <<EOF
306          subroutine tcall( string )
307          character*(*) string
308          call tsub( string )
309          end
310    EOF
311        $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1
312        RETVAL=$?
313        if test "x$RETVAL" != x0 ; then
314            cat genmake_tcomp.log >> genmake_errors
315            FC_NAMEMANGLE=$default_nm
316            echo
317            echo "WARNING: FORTRAN test compile fails -- please see \"genmake_errors\""
318            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
319            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
320            return 1
321        fi
322        f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`
323        RETVAL=$?
324        if test "x$RETVAL" != x0 ; then
325            FC_NAMEMANGLE=$default_nm
326            echo
327            echo "WARNING: The \"nm\" command failed."
328            echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"
329            echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."
330            return 1
331        fi
332    
333        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
334        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
335        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
336        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
337    
338        nmangle="X"
339        if test "x$c_a" != "x$f_a" ; then
340            comm="echo x$f_a | sed -e 's|x$c_a||'"
341            a=`eval $comm`
342            nmangle="$a ## $nmangle"
343        fi
344        if test "x$c_b" != "x$f_b" ; then
345            comm="echo x$f_b | sed -e 's|x$c_b||'"
346            b=`eval $comm`
347            nmangle="$nmangle ## $b"
348        fi
349    
350        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
351    
352        #  cleanup the testing files
353        rm -f genmake_tcomp.* genmake_test.*
354    }
355    
356  #  Set defaults here  #  Set defaults here
357  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 292  S64= Line 362  S64=
362  KPP=  KPP=
363  FC=  FC=
364  LINK=  LINK=
365  DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
366    DEFINES=
367  PACKAGES=  PACKAGES=
368  ENABLE=  ENABLE=
369  DISABLE=  DISABLE=
# Line 379  echo "===  Processing options files and Line 450  echo "===  Processing options files and
450  gm_local="genmake_local"  gm_local="genmake_local"
451  for i in . $MODS ; do  for i in . $MODS ; do
452      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
453          source $i/$gm_local          . $i/$gm_local
454          break          break
455      fi      fi
456  done  done
457  echo -n "  getting local config information:  "  echo -n "  getting local config information:  "
458  if test -e $gm_local ; then  if test -e $gm_local ; then
459      echo "using $gm_local"      echo "using $gm_local"
460      source $gm_local      . $gm_local
461      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
462      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
463  else  else
# Line 590  fi Line 661  fi
661  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
662      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
663          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
664          source "$OPTFILE"          . "$OPTFILE"
665          RETVAL=$?          RETVAL=$?
666          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
667              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""
# Line 617  fi Line 688  fi
688  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
689      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
690          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
691          source "$AD_OPTFILE"          . "$AD_OPTFILE"
692          RETVAL=$?          RETVAL=$?
693          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
694              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
# Line 633  if test "x${AD_OPTFILE}" != xNONE ; then Line 704  if test "x${AD_OPTFILE}" != xNONE ; then
704      fi      fi
705  fi  fi
706    
707  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, S64, and LN are defined.  If not,
708  #  and abort!  #  complain and abort!
709  if test "x$FC" = x ; then  if test "x$FC" = x ; then
710      cat <<EOF 1>&2      cat <<EOF 1>&2
711    
# Line 660  Error: C pre-processor "$CPP" failed the Line 731  Error: C pre-processor "$CPP" failed the
731    
732    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
733    2) the "./genmake_local" file    2) the "./genmake_local" file
734      3) with the CPP environment variable
735    
736  EOF  EOF
737      exit 1      exit 1
# Line 669  fi Line 741  fi
741  if test "x$MAKEDEPEND" = x ; then  if test "x$MAKEDEPEND" = x ; then
742      MAKEDEPEND=makedepend      MAKEDEPEND=makedepend
743  fi  fi
744    if test "x$LN" = x ; then
745        LN="ln -s"
746    fi
747    echo "test" > genmake_test_ln
748    $LN genmake_test_ln genmake_tlink
749    RETVAL=$?
750    if test "x$RETVAL" != x0 ; then
751        cat <<EOF 1>&2
752    
753    Error: The command "ln -s" failed -- please specify a working soft-link
754      command in the optfile.
755    
756    EOF
757        exit 1
758    fi
759    rm -f genmake_test_ln genmake_tlink
760    
761  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
762  echo -n "  Do we have the system() command using $FC...  "  echo -n "  Do we have the system() command using $FC...  "
# Line 711  else Line 798  else
798  fi  fi
799  rm -f genmake_tcomp*  rm -f genmake_tcomp*
800    
801  echo -n "  The name mangling convention for $FC is...  "  echo "  The name mangling convention for $FC is...  "
802    #FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"
803  if test "x$FC_NAMEMANGLE" = x ; then  if test "x$FC_NAMEMANGLE" = x ; then
804      FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) X ## _"      get_fortran_c_namemangling
 fi  
 cat > genmake_tcomp.f <<EOF  
       subroutine tcall( string )  
       character*(*) string  
       call tsub( string )  
       end  
 EOF  
 $FC $FFLAGS $DEFINES -c genmake_tcomp.f > genmake_tcomp.log 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     cat genmake_tcomp.log >> genmake_errors  
     echo  
     echo "WARNING: test compile fails -- please see \"genmake_errors\""  
     echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  
     echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  
 else  
     tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`  
     RETVAL=$?  
     if test "x$RETVAL" != x0 ; then  
         echo  
         echo "WARNING: The \"nm\" command failed."  
         echo "WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'"  
         echo "WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here."  
     else  
         t0=`echo $tcall | sed -e 's|_tcall|_ ## X|g'`  
         nmres=`echo $t0 | sed -e 's|tcall_|X ## _|g'`  
         FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmres"  
         echo "'$FC_NAMEMANGLE'"  
     fi  
805  fi  fi
806    echo "    '$FC_NAMEMANGLE'"
807  echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template
808  cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1
809  RETVAL=$?  RETVAL=$?
810  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
811      mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h      mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h
812  fi  fi
 rm -f genmake_tcomp*  
813    
814    
815  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 805  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 864  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
864  #  they appear as regular source code  #  they appear as regular source code
865  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
866      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
867      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
868      RETVAL=$?      RETVAL=$?
869      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
870          rm -f make_eesupp.errors          rm -f make_eesupp.errors
# Line 842  if test ! "x${RETVAL}" = x0 ; then Line 901  if test ! "x${RETVAL}" = x0 ; then
901      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
902      exit 1      exit 1
903  fi  fi
904  source ./.pd_tmp  . ./.pd_tmp
905  rm -f ./.pd_tmp  rm -f ./.pd_tmp
906    
907  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
# Line 1436  ad_taf_output.f: ad_input_code.f Line 1495  ad_taf_output.f: ad_input_code.f
1495          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1496          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1497    
1498    adtafonly:
1499            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1500            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1501    
1502  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1503          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1504    

Legend:
Removed from v.1.29  
changed lines
  Added in v.1.37

  ViewVC Help
Powered by ViewVC 1.1.22